// Tester.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ShipList.h"

int main(int argc, char* argv[])
{
	ShipList	masterList;
	ShipList	workList;

	printf("Hello World!\n");

	DWORD			beginTick,
					endTick;
	char			foo[8];
	ShipList::eGame	which;

	srand(GetTickCount());

	printf("1: EAW\n");
	printf("2: OP\n");
	printf("\n");
	printf("Which? ");
	gets(foo);
	
	if (atoi(foo) == 1) which = ShipList::kEmpiresAtWar;
	else				which = ShipList::kOrionPirates;

	beginTick = GetTickCount();	
	if (!masterList.CreateMaster(which, false))
		printf("\n\nCould not read the shiplist files.\n"), exit(1);
	endTick = GetTickCount();

	printf("\n\nTotal parsing took %d milliseconds!\n", endTick - beginTick);

	beginTick = GetTickCount();	
	workList = masterList;
	endTick = GetTickCount();
	
	printf("\n\nCopying list to another list took %d milliseconds!  Count is %d.\n", endTick - beginTick, workList.size());

	std::list< eRace >	raceList;
	raceList.push_back(kOrion);

	beginTick = GetTickCount();	
	int32 newcount = workList.Subset(raceList);						// limit to Orions
	endTick = GetTickCount();

	printf("\n\nLimiting to Orions took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

	std::list< eHullType >	hullList;
	hullList.push_back(kFF);
	hullList.push_back(kCL);
	hullList.push_back(kDN);

	beginTick = GetTickCount();	
	newcount = workList.Subset(hullList);							// limit to FF, CL, DN
	endTick = GetTickCount();

	printf("\n\nLimiting to FF,CL,DN took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

	beginTick = GetTickCount();	
	newcount = workList.Subset(ShipList::kSubsetBPV, 120, 150);		// limit to 120-150 bpv
	endTick = GetTickCount();

	printf("\n\nLimiting to 120-150 bpv took %d milliseconds, new count is %d!\n\n\n", endTick - beginTick, newcount);

	for (int i = 0; i < 10; i++)
	{
		Ship s;
		if (workList.SelectRandomShip(s))
			printf("Random choice %d: %s\n", i, s.shipCode.c_str());
		else
			printf("Random choice <no ships found>\n");
	}

	beginTick = GetTickCount();	
	ShipList newFleet = workList.CreateFleet(3, 450);				// 3 ships, 450 bpv total
	endTick = GetTickCount();

	printf("\n\nCreateFleet selection took %d milliseconds, resulting in a fleet with:\n\t%d ships\n\t%d total bpv\n\n", endTick - beginTick, newFleet.size(), newFleet.TotalBPV());
	
	{
	int k = 1;
	for (RealShipListIter iter = newFleet.begin(); iter != newFleet.end(); iter++, k++)
		printf("Ship #%d: %s\n", k, iter->shipCode.c_str());
	}

	// #####################################3

	if (newFleet.mIsEnhancedShiplist()) {
		{
		printf("\n\nShiplist is enhanced shiplist!\n");
		printf("------------------------------------------\n");
		printf("Enhanced Shiplist tests.\n\n");

		beginTick = GetTickCount();	
		ShipList workList2 = masterList;
		endTick = GetTickCount();

		printf("\n\nCopying list to another list took %d milliseconds!  Count is %d.\n", endTick - beginTick, workList2.size());

		std::list< eRace >	raceList2;
		raceList2.push_back(kGorn);

		beginTick = GetTickCount();	
		newcount = workList2.Subset(raceList2);
		endTick = GetTickCount();

		printf("\n\nLimiting to Gorns took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

		std::list< eEnhancedRoles >	rolesList;
		rolesList.push_back(kLineShip);

		beginTick = GetTickCount();	
		newcount = workList2.Subset(rolesList);
		endTick = GetTickCount();

		printf("\n\nLimiting to enhancedRole kLineShip took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);


		std::list< eEnhancedClassTypes >	enhancedClassTypeList;
		enhancedClassTypeList.push_back(kEClassMediumCruiser);
		enhancedClassTypeList.push_back(kEClassHeavyCruiser);
		enhancedClassTypeList.push_back(kEClassNewHeavyCruiser);

		beginTick = GetTickCount();	
		newcount = workList2.Subset(enhancedClassTypeList);
		endTick = GetTickCount();

		printf("\n\nLimiting to Medium, Heavy and NewHeavy cruisers took %d milliseconds\nNew count is %d!\n\n", 
			endTick - beginTick, newcount);


		std::list< eEnhancedXTech >	xTechList;
		xTechList.push_back(kX1);
		xTechList.push_back(kX2);

		beginTick = GetTickCount();	
		newcount = workList2.Subset(xTechList, false);
		endTick = GetTickCount();

		printf("\n\nExcluding X1 and X2 ships took %d milliseconds. new count is %d!\n\n\n", 
			endTick - beginTick, newcount);


		//kSubsetYearRangeExists
		beginTick = GetTickCount();	
		newcount = workList2.Subset(ShipList::kSubsetYearRangeExists, 14, 17);		// limit to Y177-180
		endTick = GetTickCount();

		printf("\n\nLimiting to Y177-180 took %d milliseconds, new count is %d!\n\n", endTick - beginTick, newcount);


		{
		int k = 1;
		for (RealShipListIter iter = workList2.begin(); iter != workList2.end(); iter++, k++)
			printf("Ship #%d: %s  yfa:%d  yla:%d\n", k, iter->shipCode.c_str(), 
				iter->yearFirstAvail, iter->yearLastAvail);
		}
		}

		{
//			R-AxPFS
//			kF
		printf("------------------------------------------\n");
		printf("Enhanced Shiplist tests -- Romulan Freighters\n\n");

		beginTick = GetTickCount();	
		ShipList workList3 = masterList;
		endTick = GetTickCount();

		printf("\n\nCopying list to another list took %d milliseconds!  Count is %d.\n", endTick - beginTick, workList3.size());

		std::list< eRace >	raceList3;
		raceList3.push_back(kRomulan);

		beginTick = GetTickCount();	
		newcount = workList3.Subset(raceList3);
		endTick = GetTickCount();

		printf("\n\nLimiting to Romulans took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

		std::list< eHullType >	hulltype;
		hulltype.push_back(kF);

		beginTick = GetTickCount();	
		newcount = workList3.Subset(hulltype);
		endTick = GetTickCount();

		printf("\n\nLimiting to Freighters took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);
		
		Ship aShip;

		beginTick = GetTickCount();
		workList3.Find("R-AxPFS", aShip);
		endTick = GetTickCount();

		printf("\n\nFinding ship R-AxPFS took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

		}


		{
		printf("------------------------------------------\n");
		printf("Enhanced Shiplist tests -- Romulan Auxiliary PF Tenders, late era.\n\n");

		beginTick = GetTickCount();	
		ShipList workList3 = masterList;
		endTick = GetTickCount();

		printf("\n\nCopying list to another list took %d milliseconds!  Count is %d.\n", endTick - beginTick, workList3.size());

		std::list< eRace >	raceList3;
		raceList3.push_back(kRomulan);

		beginTick = GetTickCount();	
		newcount = workList3.Subset(raceList3);
		endTick = GetTickCount();

		printf("\n\nLimiting to Romulans took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);


		Ship ship;
		workList3.Find("R-AxPFS", ship);
		printf("retrieved Ship : %s  yfa:%d  yla:%d\n", ship.shipCode.c_str(), 
				ship.yearFirstAvail, ship.yearLastAvail);


		std::list< eEnhancedRoles >	rolesList2;
		rolesList2.push_back(kPFTender);

		beginTick = GetTickCount();	
		newcount = workList3.Subset(rolesList2);
		endTick = GetTickCount();

		printf("\n\nLimiting to enhancedRole kPFTender took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);


		std::list< eEnhancedClassTypes >	enhancedClassTypeList;
		enhancedClassTypeList.push_back(kEClassSmallAuxiliary);
		enhancedClassTypeList.push_back(kEClassLargeAuxiliary);
		enhancedClassTypeList.push_back(kEClassHeavyAuxiliary);
		enhancedClassTypeList.push_back(kEClassSmallFreighter);
		enhancedClassTypeList.push_back(kEClassLargeFreighter);
		enhancedClassTypeList.push_back(kEClassHeavyFreighter);
		enhancedClassTypeList.push_back(kEClassPriorityTransport);


		beginTick = GetTickCount();	
		newcount = workList3.Subset(enhancedClassTypeList);
		endTick = GetTickCount();

		printf("\n\nLimiting to Small, Large, and Heavy Aux and Freighters took %d milliseconds\nNew count is %d!\n\n", 
			endTick - beginTick, newcount);

		{
		int k = 1;
		for (RealShipListIter iter = workList3.begin(); iter != workList3.end(); iter++, k++)
			printf("Ship #%d: %s  yfa:%d  yla:%d\n", k, iter->shipCode.c_str(), 
				iter->yearFirstAvail, iter->yearLastAvail);
		}
		}


	} else {
		printf("\n\nShiplist is a standard shiplist.\n");
	}

	printf("-----------------------------------------\n");
	printf("Testing CreateFighterList\n");

	beginTick = GetTickCount();
	ShipList fighter_sl;
	fighter_sl.CreateFighterList(which, false);
	endTick = GetTickCount();

	printf("Generating fighter shiplist took %d ms. fighter shiplist contains %d fighters.\n", 
		endTick - beginTick, fighter_sl.size());

	printf("\nRemoving fighters appearing between years 175-180\n");
	beginTick = GetTickCount();	
	newcount = fighter_sl.Subset(ShipList::kSubsetYearFirstAvail, 12, 17, false);
	endTick = GetTickCount();

	printf("\n\nRemoving fighters Y175-180 took %d milliseconds, new count is %d!\n", endTick - beginTick, newcount);

	return 1;
}

