/*
 * EnhancedShipList.h
 *
 *
 * (C) 2004 FireSoul (Luc Lanthier)
 */

#if !defined(ENHANCEDSHIPLIST_H)
#define ENHANCEDSHIPLIST_H 1

enum eEnhancedClassTypes
{
	kNoEClassType = -1,
	kEClassShuttle = 0,				// smallest hull size
	kEClassPseudoFighter,

	// Civilian (and pirate) free-trader freighters
	kEClassCivilianPassengerFreighter,
	kEClassCivilianFreighter,
	kEClassPirateFreighter,

	// Freighters
	kEClassPriorityTransport,
	kEClassSmallFreighter,
	kEClassLargeFreighter,
	kEClassHeavyFreighter,

	// Auxiliary units
	kEClassSmallAuxiliary,
	kEClassLargeAuxiliary,
	kEClassHeavyAuxiliary,

	// Tugs
	kEClassHarborTug,
	kEClassLightTug,
	kEClassTug,
	kEClassNewTug,

	// Ships
	kEClassFrigate,
	kEClassDestroyer,
	kEClassWarDestroyer,
	kEClassLightCruiser,
	kEClassWarCruiser,
	kEClassHeavyWarDestroyer,
	kEClassMediumCruiser,
	kEClassHeavyCruiser,
	kEClassNewHeavyCruiser,
	kEClassHeavyBattlecruiser,
	kEClassMonitor,
	kEClassDreadnought,
	kEClassHeavyDreadnought,
	kEClassBattleship,				// largest hull size

	kEClassFirstShip = kEClassShuttle,
	kEClassLastShip = kEClassBattleship,

	// START STAR BASES: AFSNOTE: If these fields are modified, it should be noted that there are several areas in the code that rely
	// on the fact that these are the only starbase ship types.  There are also assumptions about this enum made in older sections of 
	// the tactical code.
	kEClassListeningPost,
	kEClassPlatform,
	kEClassFleetRepairDock,
	kEClassMobileBase,
	kEClassBaseStation,
	kEClassBattleStation,
	kEClassSectorBase,
	kEClassStarBase,

	kEClassFirstBase = kEClassListeningPost,
	kEClassLastBase = kEClassStarBase,

	kEClassLastVessel = kEClassLastBase,

	// Monsters
	kEClassDeadMonster,
	kEClassSmallMonster,
	kEClassMediumMonster,
	kEClassLargeMonster,

	// Misc
	kEClassBox,
	kEClassSmallAsteroid,
	kEClassLargeAsteroid,
	kEClassPlanet,
	kEClassStar,
	kEClassUnknown,
	kMaxEClasses,
};


enum eEnhancedRoles
{
	kNoEnhancedRole = -1,

	kLineShip = 0,
	kWarShip,
	kLeader,
	kDroneBombardmentShip,
	kEscort,
	kCarrier,
	kPFTender,
	kFastCruiser,
	kMauler,
	kPolice,
	kRepair,
	kCommando,
	kHospital,
	kScout,
	kSurvey,
	kBase,
	kListeningPost,
	kPlanet,
	kHomeWorld,
	kArmedWorld,
	kRoleShuttle,
	kAsteroid,
	kRoleMonster,
	kTournament,
	kNonCombatant,
	kCargo,
	kQship,
	kLocalDefense,
	kSpecial,

	kRoleWYN,
	kRoleLDR,
	kRoleCustomRace1,
	kRoleCustomRace2,
	kRoleCustomRace3,
	kRoleCustomRace4,
	kRoleCustomRace5,
	kRoleCustomRace6,
	kRoleCustomRace7,
	kRoleCustomRace8,
	kRoleCustomRace9,
	kRoleCustomRace10,
	kRoleCustomRace11,
	kRoleCustomRace12,
	kRoleCustomRace13,
	kRoleCustomRace14,
	kRoleCustomRace15,
	kRoleCustomRace16,
	kRoleCustomRace17,
	kRoleCustomRace18,
	kRoleCustomRace19,
	
	kMaxEnchancedRoles,
	kLastRole = kSpecial,

};

enum eEnhancedXTech
{
	kNoXtech = -1,
	kX1 = 0,
	kX2 = 1,
};

enum eEnhancedProductionAvailability
{
	kNoProductionAvailability = -1,
	kConjectural = 0,
	kUnique = 1,
	kRare = 2,
	kCommon = 3,
	kMany = 4,
};
#endif