/*
 * WeaponMount.h
 *
 * Defines a weapon and all it's characteristics as defined by the
 * specification file.  Used in a collection class for Ship.
 *
 * (C) 2001 MagnumMan-iCoP (James E. King, III)
 */

#include "sysbaseenums.h"

// The hardpoint mount is defined in the Ship class as the
// map lookup entry.

class WeaponMount
{
public:

	eShipSystemType		weaponType;		// Ex: kShipSystemPhaser1
	int32				count;			// Ex: 2xPh1 would be 2
	eWeaponArc			weaponArc;		// Ex: kWeaponArcFA

	std::string			weaponTypeStr;	// Ex: "Ph1"
	std::string			weaponArcStr;	// Ex: "FH"
	
	// Fighters Only

	int32				shots;			// Only used by fighters
};
