/*
 * Tokenizer.h
 *
 * (C) 2001 MagnumMan-iCoP (James E. King, III)
 */

#include <string>

class Tokenizer
{
private:
	
	int				pos;
	std::string		input;
	std::string		tokenChars;

	std::string		work;		// Tokenizer should only be used in a single thread

protected:


	void	getNextToken(void)
	{
		work = "";

		for (;;)
		{
			char ch[2];
			
			ch[0] = input[pos++];
			ch[1] = 0;

			if (strchr(tokenChars.c_str(), ch[0]))
				break;

			work.append(ch);
		}
	}


public:

	Tokenizer(const char *data, const char *tokens)
	{
		input = data;
		tokenChars.append("\n\r");
		tokenChars.append(tokens);
		pos = 0;
	}

	~Tokenizer()
	{
	}
	
	const char *	getNextTokenC(void) { getNextToken(); return work.c_str(); }
	int				getNextTokenI(void) { getNextToken(); return atoi(work.c_str()); }
	float			getNextTokenF(void) { getNextToken(); return atof(work.c_str()); }


	void	skipNextToken(void)
	{
		for (;;)
		{
			char ch[2];
			
			ch[0] = input[pos++];
			ch[1] = 0;

			if (strchr(tokenChars.c_str(), ch[0]))
				break;
		}
	}
};
	
